program = [109,424,203,1,21101,11,0,0,1105,1,282,21101,18,0,0,1105,1,259,2101,0,1,221,203,1,21101,31,0,0,1106,0,282,21102,1,38,0,1106,0,259,21002,23,1,2,22102,1,1,3,21101,0,1,1,21101,0,57,0,1105,1,303,1202,1,1,222,21002,221,1,3,20102,1,221,2,21102,259,1,1,21101,0,80,0,1105,1,225,21101,104,0,2,21101,0,91,0,1106,0,303,2101,0,1,223,20102,1,222,4,21101,0,259,3,21102,1,225,2,21102,1,225,1,21102,1,118,0,1106,0,225,20102,1,222,3,21101,67,0,2,21102,133,1,0,1105,1,303,21202,1,-1,1,22001,223,1,1,21102,148,1,0,1105,1,259,1202,1,1,223,20102,1,221,4,21001,222,0,3,21101,0,18,2,1001,132,-2,224,1002,224,2,224,1001,224,3,224,1002,132,-1,132,1,224,132,224,21001,224,1,1,21101,195,0,0,105,1,109,20207,1,223,2,21001,23,0,1,21101,-1,0,3,21102,214,1,0,1105,1,303,22101,1,1,1,204,1,99,0,0,0,0,109,5,1202,-4,1,249,22101,0,-3,1,22102,1,-2,2,21202,-1,1,3,21101,250,0,0,1106,0,225,21202,1,1,-4,109,-5,2106,0,0,109,3,22107,0,-2,-1,21202,-1,2,-1,21201,-1,-1,-1,22202,-1,-2,-2,109,-3,2106,0,0,109,3,21207,-2,0,-1,1206,-1,294,104,0,99,21201,-2,0,-2,109,-3,2106,0,0,109,5,22207,-3,-4,-1,1206,-1,346,22201,-4,-3,-4,21202,-3,-1,-1,22201,-4,-1,2,21202,2,-1,-1,22201,-4,-1,1,21202,-2,1,3,21102,343,1,0,1106,0,303,1105,1,415,22207,-2,-3,-1,1206,-1,387,22201,-3,-2,-3,21202,-2,-1,-1,22201,-3,-1,3,21202,3,-1,-1,22201,-3,-1,2,22101,0,-4,1,21101,384,0,0,1106,0,303,1106,0,415,21202,-4,-1,-4,22201,-4,-3,-4,22202,-3,-2,-2,22202,-2,-4,-4,22202,-3,-2,-3,21202,-4,-1,-2,22201,-3,-2,1,21201,1,0,-4,109,-5,2106,0,0];
% 
% [~, ~, output] = d09_intcode(program, [0,0]);
% 
% numPointsAffected = 0;
% for x = 0:49
%     for y = 0:49
%         numPointsAffected = numPointsAffected + d09_intcode(program, [x,y]);
%     end
% end

% grid = false(1e2,1e2);
% tic
% for x = 0:size(grid,2)
%     for y = 0:size(grid,1)
%         grid(y+1,x+1) = d09_intcode(program, [x,y]) == 1;
%     end
% end
% toc

%Track the bottom limit of the beam
x = 6;
y = 8;
while true
    x = x+1;
    assert(d09_intcode(program, [x,y]) == 1);
    incr = 0;
    foundLimit = false;
    while ~foundLimit
        test = d09_intcode(program, [x,y+incr]);
        if test == 0
            y = y+incr-1;
            foundLimit = true;
        end
        incr = incr+1;
    end
    [x,y]
    if y > 100 && ...
            d09_intcode(program, [x+99,y]) == 1 && ...
            d09_intcode(program, [x+99,y-99]) == 1 && ...
            d09_intcode(program, [x,y-99]) == 1 && ...
            d09_intcode(program, [x,y]) == 1
        [x,y]
        break;
    end            
end
    

% x = 100;
% y = 100;
% candidates = zeros(0,2);
% while true
%     tr = 0;
%     bl = 0;
%     br = 0;
%     tl = d09_intcode(program, [x,y]);
%     if tl == 1
%         tr = d09_intcode(program, [x+99,y]);
%         if tr == 1
%             bl = d09_intcode(program, [x,y+99]);
%             if bl == 1            
%                 br = d09_intcode(program, [x+99,y+99]);
%             end
%         end
%     end
%     if all([tl tr bl br] == 1)
%         [x,y]
%         candidates(end+1,:) = [x,y];
%         x = x-1;
%         y = y-1;
%     else
%         x = x+10;
%         y = y+10;
%     end
% end
% 
%                 
